Index: src/sas/qtgui/GUITests.py
===================================================================
--- src/sas/qtgui/GUITests.py	(revision da9a07226e9e59e05151f1ed443b9554788d1294)
+++ src/sas/qtgui/GUITests.py	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
@@ -44,4 +44,8 @@
 from Utilities.UnitTesting import GuiUtilsTest
 from Utilities.UnitTesting import SasviewLoggerTest
+from Utilities.UnitTesting import GridPanelTest
+from Utilities.UnitTesting import ModelEditorTest
+from Utilities.UnitTesting import PluginDefinitionTest
+from Utilities.UnitTesting import TabbedModelEditorTest
 
 # Unit Testing
@@ -99,4 +103,8 @@
         unittest.makeSuite(GuiUtilsTest.DoubleValidatorTest,      'test'),
         unittest.makeSuite(GuiUtilsTest.HashableStandardItemTest, 'test'),
+        unittest.makeSuite(GridPanelTest.BatchOutputPanelTest,    'test'),
+        unittest.makeSuite(ModelEditorTest.ModelEditorTest,            'test'),
+        unittest.makeSuite(PluginDefinitionTest.PluginDefinitionTest,  'test'),
+        unittest.makeSuite(TabbedModelEditorTest.TabbedModelEditorTest,'test'),
 
         # Calculators
Index: src/sas/qtgui/MainWindow/DataExplorer.py
===================================================================
--- src/sas/qtgui/MainWindow/DataExplorer.py	(revision e90988cd3c71ed989b47df2bed55bcd11e7733ce)
+++ src/sas/qtgui/MainWindow/DataExplorer.py	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
@@ -476,16 +476,9 @@
         self.chkBatch.setEnabled(self.parent.perspective().allowBatch())
 
-    def displayData(self, data_list):
+    def displayFile(self, filename=None, is_data=True):
         """
         Forces display of charts for the given filename
         """
-        plot_to_show = data_list[0]
-
-        # passed plot is used ONLY to figure out its title,
-        # so all the charts related by it can be pulled from 
-        # the data explorer indices.
-        filename = plot_to_show.filename
-        model = self.model if plot_to_show.is_data else self.theory_model
-
+        model = self.model if is_data else self.theory_model
         # Now query the model item for available plots
         plots = GuiUtils.plotsFromFilename(filename, model)
@@ -506,4 +499,15 @@
         if new_plots:
             self.plotData(new_plots)
+
+    def displayData(self, data_list):
+        """
+        Forces display of charts for the given data set
+        """
+        plot_to_show = data_list[0]
+        # passed plot is used ONLY to figure out its title,
+        # so all the charts related by it can be pulled from 
+        # the data explorer indices.
+        filename = plot_to_show.filename
+        self.displayFile(filename=filename, is_data=plot_to_show.is_data)
 
     def addDataPlot2D(self, plot_set, item):
Index: src/sas/qtgui/MainWindow/GuiManager.py
===================================================================
--- src/sas/qtgui/MainWindow/GuiManager.py	(revision 14ec91c506393c404c69a71e75131fb3d62e4230)
+++ src/sas/qtgui/MainWindow/GuiManager.py	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
@@ -19,4 +19,6 @@
 
 import sas.qtgui.Utilities.ObjectLibrary as ObjectLibrary
+from sas.qtgui.Utilities.TabbedModelEditor import TabbedModelEditor
+from sas.qtgui.Utilities.PluginManager import PluginManager
 from sas.qtgui.MainWindow.UI.AcknowledgementsUI import Ui_Acknowledgements
 from sas.qtgui.MainWindow.AboutBox import AboutBox
@@ -358,4 +360,5 @@
         self.communicate.updateTheoryFromPerspectiveSignal.connect(self.updateTheoryFromPerspective)
         self.communicate.plotRequestedSignal.connect(self.showPlot)
+        self.communicate.plotFromFilenameSignal.connect(self.showPlotFromFilename)
         self.communicate.updateModelFromDataOperationPanelSignal.connect(self.updateModelFromDataOperationPanel)
 
@@ -406,5 +409,7 @@
         self._workspace.actionFit_Results.triggered.connect(self.actionFit_Results)
         self._workspace.actionChain_Fitting.triggered.connect(self.actionChain_Fitting)
+        self._workspace.actionAdd_Custom_Model.triggered.connect(self.actionAdd_Custom_Model)
         self._workspace.actionEdit_Custom_Model.triggered.connect(self.actionEdit_Custom_Model)
+        self._workspace.actionManage_Custom_Models.triggered.connect(self.actionManage_Custom_Models)
         # Window
         self._workspace.actionCascade.triggered.connect(self.actionCascade)
@@ -662,9 +667,21 @@
         pass
 
+    def actionAdd_Custom_Model(self):
+        """
+        """
+        self.model_editor = TabbedModelEditor(self)
+        self.model_editor.show()
+
     def actionEdit_Custom_Model(self):
         """
         """
-        print("actionEdit_Custom_Model TRIGGERED")
-        pass
+        self.model_editor = TabbedModelEditor(self, edit_only=True)
+        self.model_editor.show()
+
+    def actionManage_Custom_Models(self):
+        """
+        """
+        self.model_manager = PluginManager(self)
+        self.model_manager.show()
 
     #============ ANALYSIS =================
@@ -779,4 +796,11 @@
         self.filesWidget.model.appendRow(new_item)
         self._data_manager.add_data(new_datalist_item)
+
+    def showPlotFromFilename(self, filename):
+        """
+        Pass the show plot request to the data explorer
+        """
+        if hasattr(self, "filesWidget"):
+            self.filesWidget.displayFile(filename=filename, is_data=True)
 
     def showPlot(self, plot):
Index: src/sas/qtgui/MainWindow/UI/MainWindowUI.ui
===================================================================
--- src/sas/qtgui/MainWindow/UI/MainWindowUI.ui	(revision 1543f0c992549217b0c16ad382d98c5fa1cd6030)
+++ src/sas/qtgui/MainWindow/UI/MainWindowUI.ui	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
@@ -8,5 +8,5 @@
     <y>0</y>
     <width>915</width>
-    <height>527</height>
+    <height>762</height>
    </rect>
   </property>
@@ -25,5 +25,5 @@
      <y>0</y>
      <width>915</width>
-     <height>21</height>
+     <height>26</height>
     </rect>
    </property>
@@ -108,5 +108,7 @@
     <addaction name="actionChain_Fitting"/>
     <addaction name="separator"/>
+    <addaction name="actionAdd_Custom_Model"/>
     <addaction name="actionEdit_Custom_Model"/>
+    <addaction name="actionManage_Custom_Models"/>
    </widget>
    <widget class="QMenu" name="menuWindow">
@@ -505,4 +507,14 @@
    </property>
   </action>
+  <action name="actionAdd_Custom_Model">
+   <property name="text">
+    <string>Add Custom Model</string>
+   </property>
+  </action>
+  <action name="actionManage_Custom_Models">
+   <property name="text">
+    <string>Manage Custom Models</string>
+   </property>
+  </action>
  </widget>
  <resources/>
Index: src/sas/qtgui/Perspectives/Fitting/ConstraintWidget.py
===================================================================
--- src/sas/qtgui/Perspectives/Fitting/ConstraintWidget.py	(revision e4c475b769d2f7b453153dd47ec2824b13fe251d)
+++ src/sas/qtgui/Perspectives/Fitting/ConstraintWidget.py	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
@@ -111,5 +111,5 @@
 
         # Disconnect all local slots
-        tab_object.disconnect()
+        #tab_object.disconnect()
 
         # Reconnect tab signals to local slots
@@ -178,7 +178,7 @@
                             "Not all tabs chosen for fitting have parameters selected for fitting."
             QtWidgets.QMessageBox.warning(self,
-                                           'Warning',
-                                            no_params_msg,
-                                            QtWidgets.QMessageBox.Ok)
+                                          'Warning',
+                                           no_params_msg,
+                                           QtWidgets.QMessageBox.Ok)
 
             return
@@ -674,5 +674,7 @@
 
         constraint.func = constraint_text
+        # param1 is the parameter we're constraining
         constraint.param = param1
+
         # Find the right tab
         constrained_tab = self.getObjectByName(model1)
Index: src/sas/qtgui/Perspectives/Fitting/FittingPerspective.py
===================================================================
--- src/sas/qtgui/Perspectives/Fitting/FittingPerspective.py	(revision 14ec91c506393c404c69a71e75131fb3d62e4230)
+++ src/sas/qtgui/Perspectives/Fitting/FittingPerspective.py	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
@@ -8,4 +8,5 @@
 from bumps import fitters
 
+import sas.qtgui.Utilities.LocalConfig as LocalConfig
 import sas.qtgui.Utilities.ObjectLibrary as ObjectLibrary
 
@@ -116,4 +117,5 @@
         tab	= FittingWidget(parent=self.parent, data=data, tab_id=self.maxIndex+1)
         tab.is_batch_fitting = is_batch
+
         # Add this tab to the object library so it can be retrieved by scripting/jupyter
         tab_name = self.getTabName(is_batch=is_batch)
@@ -123,5 +125,11 @@
             self.updateFitDict(data, tab_name)
         self.maxIndex += 1
-        self.addTab(tab, tab_name)
+        icon = QtGui.QIcon()
+        if is_batch:
+            icon.addPixmap(QtGui.QPixmap("src/sas/qtgui/images/icons/layers.svg"))
+        self.addTab(tab, icon, tab_name)
+        # Show the new tab
+        self.setCurrentIndex(self.maxIndex-1)
+        # Notify listeners
         self.tabsModifiedSignal.emit()
 
@@ -140,5 +148,10 @@
         ObjectLibrary.addObject(tab_name, tab)
         self.tabs.append(tab)
-        self.addTab(tab, tab_name)
+        icon = QtGui.QIcon()
+        icon.addPixmap(QtGui.QPixmap("src/sas/qtgui/images/icons/link.svg"))
+        self.addTab(tab, icon, tab_name)
+
+        # This will be the last tab, so set the index accordingly
+        self.setCurrentIndex(self.count()-1)
 
     def updateFitDict(self, item_key, tab_name):
Index: src/sas/qtgui/Perspectives/Fitting/FittingWidget.py
===================================================================
--- src/sas/qtgui/Perspectives/Fitting/FittingWidget.py	(revision e4c475b769d2f7b453153dd47ec2824b13fe251d)
+++ src/sas/qtgui/Perspectives/Fitting/FittingWidget.py	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
@@ -24,4 +24,5 @@
 import sas.qtgui.Utilities.GuiUtils as GuiUtils
 import sas.qtgui.Utilities.LocalConfig as LocalConfig
+from sas.qtgui.Utilities.GridPanel import BatchOutputPanel
 from sas.qtgui.Utilities.CategoryInstaller import CategoryInstaller
 from sas.qtgui.Plotting.PlotterData import Data1D
@@ -36,4 +37,5 @@
 from sas.qtgui.Perspectives.Fitting.FittingLogic import FittingLogic
 from sas.qtgui.Perspectives.Fitting import FittingUtilities
+from sas.qtgui.Perspectives.Fitting import ModelUtilities
 from sas.qtgui.Perspectives.Fitting.SmearingWidget import SmearingWidget
 from sas.qtgui.Perspectives.Fitting.OptionsWidget import OptionsWidget
@@ -50,4 +52,5 @@
 CATEGORY_DEFAULT = "Choose category..."
 CATEGORY_STRUCTURE = "Structure Factor"
+CATEGORY_CUSTOM = "Plugin Models"
 STRUCTURE_DEFAULT = "None"
 
@@ -83,4 +86,7 @@
     constraintAddedSignal = QtCore.pyqtSignal(list)
     newModelSignal = QtCore.pyqtSignal()
+    fittingFinishedSignal = QtCore.pyqtSignal(tuple)
+    batchFittingFinishedSignal = QtCore.pyqtSignal(tuple)
+
     def __init__(self, parent=None, data=None, tab_id=1):
 
@@ -211,4 +217,7 @@
         self.page_stack = []
         self.all_data = []
+        # custom plugin models
+        # {model.name:model}
+        self.custom_models = self.customModels()
         # Polydisp widget table default index for function combobox
         self.orig_poly_index = 3
@@ -415,4 +424,8 @@
             self.onSelectModel()
 
+    def customModels(self):
+        """ Reads in file names in the custom plugin directory """
+        return ModelUtilities._find_models()
+
     def initializeControls(self):
         """
@@ -465,7 +478,15 @@
         self._poly_model.itemChanged.connect(self.onPolyModelChange)
         self._magnet_model.itemChanged.connect(self.onMagnetModelChange)
+        self.lstParams.selectionModel().selectionChanged.connect(self.onSelectionChanged)
+
+        # Local signals
+        self.batchFittingFinishedSignal.connect(self.batchFitComplete)
+        self.fittingFinishedSignal.connect(self.fitComplete)
 
         # Signals from separate tabs asking for replot
         self.options_widget.plot_signal.connect(self.onOptionsUpdate)
+
+        # Signals from other widgets
+        self.communicate.customModelDirectoryChanged.connect(self.onCustomModelChange)
 
     def modelName(self):
@@ -576,7 +597,12 @@
         # widget.params[0] is the parameter we're constraining
         constraint.param = mc_widget.params[0]
-        # Function should have the model name preamble
+        # parameter should have the model name preamble
         model_name = self.kernel_module.name
-        constraint.func = model_name + "." + c_text
+        # param_used is the parameter we're using in constraining function
+        param_used = mc_widget.params[1]
+        # Replace param_used with model_name.param_used
+        updated_param_used = model_name + "." + param_used
+        new_func = c_text.replace(param_used, updated_param_used)
+        constraint.func = new_func
         # Which row is the constrained parameter in?
         row = self.getRowFromName(constraint.param)
@@ -677,5 +703,8 @@
         Delete constraints from selected parameters.
         """
-        self.deleteConstraintOnParameter(param=None)
+        params =  [s.data() for s in self.lstParams.selectionModel().selectedRows()
+                   if self.isCheckable(s.row())]
+        for param in params:
+            self.deleteConstraintOnParameter(param=param)
 
     def deleteConstraintOnParameter(self, param=None):
@@ -686,9 +715,9 @@
         max_col = self.lstParams.itemDelegate().param_max
         for row in range(self._model_model.rowCount()):
+            if not self.rowHasConstraint(row):
+                continue
             # Get the Constraint object from of the model item
             item = self._model_model.item(row, 1)
-            if not item.hasChildren():
-                continue
-            constraint = item.child(0).data()
+            constraint = self.getConstraintForRow(row)
             if constraint is None:
                 continue
@@ -816,4 +845,41 @@
         return constraints
 
+    def getConstraintsForFitting(self):
+        """
+        Return a list of constraints in format ready for use in fiting
+        """
+        # Get constraints
+        constraints = self.getComplexConstraintsForModel()
+        # See if there are any constraints across models
+        multi_constraints = [cons for cons in constraints if self.isConstraintMultimodel(cons[1])]
+
+        if multi_constraints:
+            # Let users choose what to do
+            msg = "The current fit contains constraints relying on other fit pages.\n"
+            msg += "Parameters with those constraints are:\n" +\
+                '\n'.join([cons[0] for cons in multi_constraints])
+            msg += "\n\nWould you like to remove these constraints or cancel fitting?"
+            msgbox = QtWidgets.QMessageBox(self)
+            msgbox.setIcon(QtWidgets.QMessageBox.Warning)
+            msgbox.setText(msg)
+            msgbox.setWindowTitle("Existing Constraints")
+            # custom buttons
+            button_remove = QtWidgets.QPushButton("Remove")
+            msgbox.addButton(button_remove, QtWidgets.QMessageBox.YesRole)
+            button_cancel = QtWidgets.QPushButton("Cancel")
+            msgbox.addButton(button_cancel, QtWidgets.QMessageBox.RejectRole)
+            retval = msgbox.exec_()
+            if retval == QtWidgets.QMessageBox.RejectRole:
+                # cancel fit
+                raise ValueError("Fitting cancelled")
+            else:
+                # remove constraint
+                for cons in multi_constraints:
+                    self.deleteConstraintOnParameter(param=cons[0])
+                # re-read the constraints
+                constraints = self.getComplexConstraintsForModel()
+
+        return constraints
+
     def showModelDescription(self):
         """
@@ -874,4 +940,42 @@
         self.respondToModelStructure(model=model, structure_factor=structure)
 
+    def onCustomModelChange(self):
+        """
+        Reload the custom model combobox
+        """
+        self.custom_models = self.customModels()
+        self.readCustomCategoryInfo()
+        # See if we need to update the combo in-place
+        if self.cbCategory.currentText() != CATEGORY_CUSTOM: return
+
+        current_text = self.cbModel.currentText()
+        self.cbModel.blockSignals(True)
+        self.cbModel.clear()
+        self.cbModel.blockSignals(False)
+        self.enableModelCombo()
+        self.disableStructureCombo()
+        # Retrieve the list of models
+        model_list = self.master_category_dict[CATEGORY_CUSTOM]
+        # Populate the models combobox
+        self.cbModel.addItems(sorted([model for (model, _) in model_list]))
+        new_index = self.cbModel.findText(current_text)
+        if new_index != -1:
+            self.cbModel.setCurrentIndex(self.cbModel.findText(current_text))
+
+    def onSelectionChanged(self):
+        """
+        React to parameter selection
+        """
+        rows = self.lstParams.selectionModel().selectedRows()
+        # Clean previous messages
+        self.communicate.statusBarUpdateSignal.emit("")
+        if len(rows) == 1:
+            # Show constraint, if present
+            row = rows[0].row()
+            if self.rowHasConstraint(row):
+                func = self.getConstraintForRow(row).func
+                if func is not None:
+                    self.communicate.statusBarUpdateSignal.emit("Active constrain: "+func)
+
     def replaceConstraintName(self, old_name, new_name=""):
         """
@@ -886,4 +990,14 @@
                     new_func = func.replace(old_name, new_name)
                     self._model_model.item(row, 1).child(0).data().func = new_func
+
+    def isConstraintMultimodel(self, constraint):
+        """
+        Check if the constraint function text contains current model name
+        """
+        current_model_name = self.kernel_module.name
+        if current_model_name in constraint:
+            return False
+        else:
+            return True
 
     def updateData(self):
@@ -937,5 +1051,5 @@
             self._model_model.clear()
             return
-
+            
         # Safely clear and enable the model combo
         self.cbModel.blockSignals(True)
@@ -1105,9 +1219,9 @@
         except ValueError as ex:
             # This should not happen! GUI explicitly forbids this situation
-            self.communicate.statusBarUpdateSignal.emit('Fitting attempt without parameters.')
+            self.communicate.statusBarUpdateSignal.emit(str(ex))
             return
 
         # Create the fitting thread, based on the fitter
-        completefn = self.batchFitComplete if self.is_batch_fitting else self.fitComplete
+        completefn = self.batchFittingCompleted if self.is_batch_fitting else self.fittingCompleted
 
         calc_fit = FitThread(handler=handler,
@@ -1146,4 +1260,10 @@
         pass
 
+    def batchFittingCompleted(self, result):
+        """
+        Send the finish message from calculate threads to main thread
+        """
+        self.batchFittingFinishedSignal.emit(result)
+
     def batchFitComplete(self, result):
         """
@@ -1152,4 +1272,13 @@
         #re-enable the Fit button
         self.setFittingStopped()
+        # Show the grid panel
+        self.grid_window = BatchOutputPanel(parent=self, output_data=result[0])
+        self.grid_window.show()
+
+    def fittingCompleted(self, result):
+        """
+        Send the finish message from calculate threads to main thread
+        """
+        self.fittingFinishedSignal.emit(result)
 
     def fitComplete(self, result):
@@ -1162,5 +1291,5 @@
 
         if result is None:
-            msg = "Fitting failed after: %s s.\n" % GuiUtils.formatNumber(elapsed)
+            msg = "Fitting failed."
             self.communicate.statusBarUpdateSignal.emit(msg)
             return
@@ -1228,5 +1357,6 @@
         smearing, accuracy, smearing_min, smearing_max = self.smearing_widget.state()
 
-        constraints = self.getComplexConstraintsForModel()
+        constraints = self.getConstraintsForFitting()
+
         smearer = None
         handler = None
@@ -1242,6 +1372,5 @@
                              constraints=constraints)
             except ValueError as ex:
-                logging.error("Setting model parameters failed with: %s" % ex)
-                return
+                raise ValueError("Setting model parameters failed with: %s" % ex)
 
             qmin, qmax, _ = self.logic.computeRangeFromData(data)
@@ -1409,5 +1538,5 @@
         if not dict:
             return
-        if self._model_model.rowCount() == 0:
+        if self._magnet_model.rowCount() == 0:
             return
 
@@ -1555,4 +1684,18 @@
             self.models[model.name] = model
 
+        self.readCustomCategoryInfo()
+
+    def readCustomCategoryInfo(self):
+        """
+        Reads the custom model category
+        """
+        #Looking for plugins
+        self.plugins = list(self.custom_models.values())
+        plugin_list = []
+        for name, plug in self.custom_models.items():
+            self.models[name] = plug
+            plugin_list.append([name, True])
+        self.master_category_dict[CATEGORY_CUSTOM] = plugin_list
+
     def regenerateModelDict(self):
         """
@@ -1662,5 +1805,9 @@
         Setting model parameters into QStandardItemModel based on selected _model_
         """
-        kernel_module = generate.load_kernel_module(model_name)
+        name = model_name
+        if self.cbCategory.currentText() == CATEGORY_CUSTOM:
+            # custom kernel load requires full path
+            name = os.path.join(ModelUtilities.find_plugins_dir(), model_name+".py")
+        kernel_module = generate.load_kernel_module(name)
         self.model_parameters = modelinfo.make_parameter_table(getattr(kernel_module, 'parameters', []))
 
Index: src/sas/qtgui/Perspectives/Fitting/ModelUtilities.py
===================================================================
--- src/sas/qtgui/Perspectives/Fitting/ModelUtilities.py	(revision b3e8629bf18b74f4214d6552e620fcbc4e73a28c)
+++ src/sas/qtgui/Perspectives/Fitting/ModelUtilities.py	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
@@ -179,4 +179,5 @@
     plugins = {}
     for filename in os.listdir(directory):
+
         name, ext = os.path.splitext(filename)
         if ext == '.py' and not name == '__init__':
@@ -184,5 +185,5 @@
             try:
                 model = load_custom_model(path)
-                model.name = PLUGIN_NAME_BASE + model.name
+                #model.name = PLUGIN_NAME_BASE + model.name
                 plugins[model.name] = model
             except Exception:
@@ -415,10 +416,12 @@
     implement model
     """
-    __modelmanager = ModelManagerBase()
-    cat_model_list = [__modelmanager.model_dictionary[model_name] for model_name \
-                      in list(__modelmanager.model_dictionary.keys()) \
-                      if model_name not in list(__modelmanager.stored_plugins.keys())]
-
-    CategoryInstaller.check_install(model_list=cat_model_list)
+    def __init__(self):
+        self.__modelmanager = ModelManagerBase()
+        self.cat_model_list = [self.__modelmanager.model_dictionary[model_name] for model_name \
+                          in list(self.__modelmanager.model_dictionary.keys()) \
+                          if model_name not in list(self.__modelmanager.stored_plugins.keys())]
+
+        CategoryInstaller.check_install(model_list=self.cat_model_list)
+
     def findModels(self):
         return self.__modelmanager.findModels()
Index: src/sas/qtgui/Perspectives/Fitting/MultiConstraint.py
===================================================================
--- src/sas/qtgui/Perspectives/Fitting/MultiConstraint.py	(revision 14ec91c506393c404c69a71e75131fb3d62e4230)
+++ src/sas/qtgui/Perspectives/Fitting/MultiConstraint.py	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
@@ -114,12 +114,12 @@
 
         # 3. parameter name should be a separate word, but can have "()[]*+-/ " around
-        valid_neighbours = "()[]*+-/ "
-        start_loc = parameter_string_start -1
-        end_loc = parameter_string_end
-        if not any([constraint_text[start_loc] == ch for ch in valid_neighbours]):
-            return False
-        if end_loc < len(constraint_text):
-            if not any([constraint_text[end_loc] == ch for ch in valid_neighbours]):
-                return False
+        #valid_neighbours = "()[]*+-/ "
+        #start_loc = parameter_string_start -1
+        #end_loc = parameter_string_end
+        #if not any([constraint_text[start_loc] == ch for ch in valid_neighbours]):
+        #    return False
+        #if end_loc < len(constraint_text):
+        #    if not any([constraint_text[end_loc] == ch for ch in valid_neighbours]):
+        #        return False
 
         # 4. replace parameter name with "1" and try to evaluate the expression
Index: src/sas/qtgui/Perspectives/Fitting/UI/FittingWidgetUI.ui
===================================================================
--- src/sas/qtgui/Perspectives/Fitting/UI/FittingWidgetUI.ui	(revision e4c475b769d2f7b453153dd47ec2824b13fe251d)
+++ src/sas/qtgui/Perspectives/Fitting/UI/FittingWidgetUI.ui	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
@@ -7,5 +7,5 @@
     <x>0</x>
     <y>0</y>
-    <width>568</width>
+    <width>680</width>
     <height>605</height>
    </rect>
Index: src/sas/qtgui/Perspectives/Fitting/UnitTesting/ConstraintWidgetTest.py
===================================================================
--- src/sas/qtgui/Perspectives/Fitting/UnitTesting/ConstraintWidgetTest.py	(revision 725d9c06c2a66018f1352faba2f96cd31d8e9654)
+++ src/sas/qtgui/Perspectives/Fitting/UnitTesting/ConstraintWidgetTest.py	(revision 3b3b40bf9d5056d902b19728c621dd2a4661d65f)
@@ -22,5 +22,4 @@
 if not QtWidgets.QApplication.instance():
     app = QtWidgets.QApplication(sys.argv)
-#app = QtWidgets.QApplication(sys.argv)
 
 class ConstraintWidgetTest(unittest.TestCase):
@@ -71,5 +70,5 @@
         # click on "batch"
         QTest.mouseClick(self.widget.btnBatch, QtCore.Qt.LeftButton)
-        app.processEvents()
+        QtWidgets.QApplication.processEvents()
         # See what the current type is now
         self.assertEqual(self.widget.currentType, "BatchPage")
@@ -78,5 +77,5 @@
         # Go back to single fit
         QTest.mouseClick(self.widget.btnSingle, QtCore.Qt.LeftButton)
-        app.processEvents()
+        QtWidgets.QApplication.processEvents()
         # See what the current type is now
         self.assertEqual(self.widget.currentType, "FitPage")
